
static const uint32_t DATA_LUT[]={
  0x00000000,
  0x04000000,
  0x00010000,
  0x04010000,
  0x02000000,
  0x06000000,
  0x02010000,
  0x06010000,
  0x01000000,
  0x05000000,
  0x01010000,
  0x05010000,
  0x03000000,
  0x07000000,
  0x03010000,
  0x07010000,
  0x00100000,
  0x04100000,
  0x00110000,
  0x04110000,
  0x02100000,
  0x06100000,
  0x02110000,
  0x06110000,
  0x01100000,
  0x05100000,
  0x01110000,
  0x05110000,
  0x03100000,
  0x07100000,
  0x03110000,
  0x07110000,
  0x00200000,
  0x04200000,
  0x00210000,
  0x04210000,
  0x02200000,
  0x06200000,
  0x02210000,
  0x06210000,
  0x01200000,
  0x05200000,
  0x01210000,
  0x05210000,
  0x03200000,
  0x07200000,
  0x03210000,
  0x07210000,
  0x00300000,
  0x04300000,
  0x00310000,
  0x04310000,
  0x02300000,
  0x06300000,
  0x02310000,
  0x06310000,
  0x01300000,
  0x05300000,
  0x01310000,
  0x05310000,
  0x03300000,
  0x07300000,
  0x03310000,
  0x07310000,
  0x00002000,
  0x04002000,
  0x00012000,
  0x04012000,
  0x02002000,
  0x06002000,
  0x02012000,
  0x06012000,
  0x01002000,
  0x05002000,
  0x01012000,
  0x05012000,
  0x03002000,
  0x07002000,
  0x03012000,
  0x07012000,
  0x00102000,
  0x04102000,
  0x00112000,
  0x04112000,
  0x02102000,
  0x06102000,
  0x02112000,
  0x06112000,
  0x01102000,
  0x05102000,
  0x01112000,
  0x05112000,
  0x03102000,
  0x07102000,
  0x03112000,
  0x07112000,
  0x00202000,
  0x04202000,
  0x00212000,
  0x04212000,
  0x02202000,
  0x06202000,
  0x02212000,
  0x06212000,
  0x01202000,
  0x05202000,
  0x01212000,
  0x05212000,
  0x03202000,
  0x07202000,
  0x03212000,
  0x07212000,
  0x00302000,
  0x04302000,
  0x00312000,
  0x04312000,
  0x02302000,
  0x06302000,
  0x02312000,
  0x06312000,
  0x01302000,
  0x05302000,
  0x01312000,
  0x05312000,
  0x03302000,
  0x07302000,
  0x03312000,
  0x07312000,
  0x00080000,
  0x04080000,
  0x00090000,
  0x04090000,
  0x02080000,
  0x06080000,
  0x02090000,
  0x06090000,
  0x01080000,
  0x05080000,
  0x01090000,
  0x05090000,
  0x03080000,
  0x07080000,
  0x03090000,
  0x07090000,
  0x00180000,
  0x04180000,
  0x00190000,
  0x04190000,
  0x02180000,
  0x06180000,
  0x02190000,
  0x06190000,
  0x01180000,
  0x05180000,
  0x01190000,
  0x05190000,
  0x03180000,
  0x07180000,
  0x03190000,
  0x07190000,
  0x00280000,
  0x04280000,
  0x00290000,
  0x04290000,
  0x02280000,
  0x06280000,
  0x02290000,
  0x06290000,
  0x01280000,
  0x05280000,
  0x01290000,
  0x05290000,
  0x03280000,
  0x07280000,
  0x03290000,
  0x07290000,
  0x00380000,
  0x04380000,
  0x00390000,
  0x04390000,
  0x02380000,
  0x06380000,
  0x02390000,
  0x06390000,
  0x01380000,
  0x05380000,
  0x01390000,
  0x05390000,
  0x03380000,
  0x07380000,
  0x03390000,
  0x07390000,
  0x00082000,
  0x04082000,
  0x00092000,
  0x04092000,
  0x02082000,
  0x06082000,
  0x02092000,
  0x06092000,
  0x01082000,
  0x05082000,
  0x01092000,
  0x05092000,
  0x03082000,
  0x07082000,
  0x03092000,
  0x07092000,
  0x00182000,
  0x04182000,
  0x00192000,
  0x04192000,
  0x02182000,
  0x06182000,
  0x02192000,
  0x06192000,
  0x01182000,
  0x05182000,
  0x01192000,
  0x05192000,
  0x03182000,
  0x07182000,
  0x03192000,
  0x07192000,
  0x00282000,
  0x04282000,
  0x00292000,
  0x04292000,
  0x02282000,
  0x06282000,
  0x02292000,
  0x06292000,
  0x01282000,
  0x05282000,
  0x01292000,
  0x05292000,
  0x03282000,
  0x07282000,
  0x03292000,
  0x07292000,
  0x00382000,
  0x04382000,
  0x00392000,
  0x04392000,
  0x02382000,
  0x06382000,
  0x02392000,
  0x06392000,
  0x01382000,
  0x05382000,
  0x01392000,
  0x05392000,
  0x03382000,
  0x07382000,
  0x03392000,
  0x07392000
};
#define DATA_MAX (sizeof(DATA_LUT)/sizeof(uint32_t) - 1)
#define DATA_SET_LUT(N) DATA_LUT[N]
#define DATA_CLR_LUT(N) DATA_LUT[DATA_MAX-N]

static const uint32_t ADDR_LUT[]={
  0x00000000,
  0x00000010,
  0x08000000,
  0x08000010,
  0x00400000,
  0x00400010,
  0x08400000,
  0x08400010,
  0x00000020,
  0x00000030,
  0x08000020,
  0x08000030,
  0x00400020,
  0x00400030,
  0x08400020,
  0x08400030
};
#define ADDR_MAX (sizeof(ADDR_LUT)/sizeof(uint32_t) - 1)
#define ADDR_SET_LUT(N) ADDR_LUT[N]
#define ADDR_CLR_LUT(N) ADDR_LUT[ADDR_MAX-N]

/*
#include <map>
using namespace std;

struct A{
    static map<int,int> create_map()
        {
          map<int,int> m;
          m[1] = 2;
          m[3] = 4;
          m[5] = 6;
          return m;
        }
    static const map<int,int> myMap;

};

const map<int,int> A:: myMap =  A::create_map();
*/
